//
//  main.c
//  TestHarness
//
//  Created by Marginean Alexandru on 25/03/14.
//  Copyright (c) 2014 Marginean Alexandru. All rights reserved.
//

#include <stdio.h>

#include <dirent.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


void readDirContent (char * path, char **ListOfFiles, int * pos)
{
    
    DIR           *d;
    struct dirent *dir;
    char * newPath;
    newPath = (char*)malloc(500*sizeof(char));
    strcpy(newPath,path);
    strcat(newPath, "/");
    
    d = opendir(path);
    if (d)
    {
        while ((dir = readdir(d)) != NULL)
        {
            if(dir->d_type == 4 && strcmp(".", dir->d_name) && strcmp("..", dir->d_name)){
                readDirContent(strcat(newPath,dir->d_name), ListOfFiles, pos);
            }
            else if(dir->d_name[strlen(dir->d_name)-1] == 'n'){
                strcpy(ListOfFiles[*pos], dir->d_name);
                (*pos)++;
                printf("\"%s/%s\" ", path, dir->d_name);
            }
        }
        
        closedir(d);
    }
    
}

void test(char ** Files, int pos, char * type, int threshold, int maxD, char * outputFile){
    char * testPath = "cd /Users/margineanalexandru/Documents/workspace/CloneDetection \n";
    char outputFileName [250];
    sprintf(outputFileName, "/Users/margineanalexandru/Documents/workspace/CloneDetection/output/%s", outputFile);
    FILE * fout = fopen(outputFileName,"w");
    fprintf(fout, "\\begin{table}[H] \n \\centering \n  \\begin{tabular}{  | c | c | c | c | c | c | c | } \n \\hline \n  \\textbf{No.\\cellcolor{gray}  }  & \\textbf{Source\\cellcolor{gray}  }  &  \\textbf{CloneFile}\\cellcolor{gray} &  \\textbf{Type} \\cellcolor{gray} &  \\textbf{Thresh\\cellcolor{gray} } &  \\textbf{MaxD\\cellcolor{gray} } &\\textbf{Result\\cellcolor{gray} }  \\\\ \\hline\n");
    int number = 1;
    	int i = 0;
	for(i = 0; i < pos; i++){
        int j;
	for (j = 0; j<pos; j++) {
            FILE *fp;
            char path[1035];
            char command [250];
            sprintf(command, "%s ./CloneDetectorMain input/%s input/%s -type %s -threshold %d -maxD %d", testPath, Files[i], Files[j], type, threshold, maxD);
            fp = popen(command, "r");
            if (fp == NULL) {
                printf("Failed to run command\n" );
                //exit;
            }
            
            while (fgets(path, sizeof(path)-1, fp) != NULL) {
                //printf("citit!!! %s", path);
            }
            char result[1000];
            sprintf(result, "%d\\cellcolor{yellow} & %s & %s & 1 & 3  & NOT & %s\\\\ \\hline\n", number, Files[i], Files[j], path);
            fprintf(fout, result);
            number ++;
            
        }
    }
    fprintf(fout,"\\end{tabular} \n \\end{table}");
    fclose(fout);
    printf("FINISHED 1 TEST!");
}

int main(int argc, const char * argv[])
{
    
    char **ListOfFiles;
    ListOfFiles = (char**)malloc(250 * sizeof(char*));
    
    for(int i = 0; i < 250; i ++){
        ListOfFiles[i] = (char*)malloc(250*sizeof(char));
    }
    
    int *pos;
    pos = (int*)malloc(sizeof(int));
    *pos = 0;
    char * Path = "/Users/margineanalexandru/Documents/workspace/CloneDetection/input";
    readDirContent(Path,ListOfFiles,pos);
    //test(ListOfFiles, *pos, "1", 3, 1, "type1thres3.out");
    //test(ListOfFiles, *pos, "2", 3, 1, "type2thres3.out");
    //test(ListOfFiles, *pos, "3a", 3, 6, "type3athres3Maxd6.out");
    test(ListOfFiles, *pos, "3b", 3, 6, "type3bthres3Maxd6.out");
    
    test(ListOfFiles, *pos, "1", 6, 1, "type1thres6.out");
    test(ListOfFiles, *pos, "2", 6, 1, "type2thres6.out");
    test(ListOfFiles, *pos, "3a", 6, 6, "type3athres6Maxd6.out");
    test(ListOfFiles, *pos, "3b", 6, 6, "type3bthres6Maxd6.out");
    // insert code here...
    printf("Hello, World!\n");
    return 0;
}

